var timeout;
document.documentElement.addEventListener('touchstart', function (event) {
    if (event.touches.length > 1) {
      event.preventDefault();
    }
  }, false);

function mouseDown(e){
    this.draw=true;
    this.ctx = this.getContext("2d");
    this.ctx.strokeStyle='#000000';
    this.ctx.lineWidth=16;

    var o=this;
    this.offsetX=this.offsetLeft;
    this.offsetY=this.offsetTop;

    while(o.offsetParent){
    	o=o.offsetParent;
    	this.offsetX+=o.offsetLeft;
    	this.offsetY+=o.offsetTop;
    }

    this.ctx.beginPath();
    this.ctx.moveTo(e.pageX-this.offsetX,e.pageY-this.offsetY);
}

function mouseMove(e){
    if (this.draw){
        this.ctx.lineTo(e.pageX-this.offsetX,e.pageY-this.offsetY);
        this.ctx.stroke();
    }
}

function mouseUp(e){
    this.draw=false;
    timeoutSend();
}

function touchStart(e){
    this.draw=true;
    this.ctx=this.getContext("2d");
    this.touch=e.targetTouches[0];
    this.ctx.strokeStyle='#000000';
    this.ctx.lineWidth=16;

    var o=this;
    this.offsetX=this.offsetLeft;
    this.offsetY=this.offsetTop;

    while(o.offsetParent){
    	o=o.offsetParent;
    	this.offsetX+=o.offsetLeft;
    	this.offsetY+=o.offsetTop;
    }

    this.ctx.beginPath();
    this.ctx.moveTo(this.touch.pageX-this.offsetX,this.touch.pageY-this.offsetY);
    e.preventDefault();
}

function touchMove(e){
    this.touch=e.targetTouches[0];
    if (this.draw){
        this.ctx.lineTo(this.touch.pageX-this.offsetX,this.touch.pageY-this.offsetY);
        this.ctx.stroke();
    }
    e.preventDefault();
}

function touchEnd(e){
    this.draw=false;
    e.preventDefault();
    timeoutSend();
}

function clearPad(){
    var canvas=document.querySelector('#myCanvas');
    var ctx=canvas.getContext("2d");
    ctx.clearRect(0,0,canvas.width,canvas.height);
    for (i=1;i<=10;i++){
        $('#l'+i).html("");
    }
}

window.addEventListener('load',function(){
    var canvas=document.querySelector('#myCanvas');

    canvas.addEventListener('mousedown',mouseDown);
    canvas.addEventListener('mousemove',mouseMove);
    canvas.addEventListener('mouseup',mouseUp);

    canvas.addEventListener('touchstart',touchStart);
    canvas.addEventListener('touchmove',touchMove);
    canvas.addEventListener('touchend',touchEnd);
});

function timeoutSend(){
    if(timeout!=null){
        clearTimeout(timeout);
    }
    timeout = setTimeout(function(){send();}, 500);
}

function onLetterClick(letter){
    $.ajax({
        url: "autoinput?letter="+letter,
        type:"POST",
        success:function(result){

        }
    });
    clearPad();
}

function send(){
    var canvas = document.getElementById("myCanvas");
    var context = canvas.getContext("2d");                    
    var imageDataURL = canvas.toDataURL('image/png');
    $.ajax({
        url: "receive?dt=" + new Date().getTime(),
        type: "POST",
        data: imageDataURL,
        contentType:false,
        processData:false,
        cache: false,
        success: function(result) {
            // Do some stuff
            console.log(result);
            
            for (i=1;i<=10;i++){
                letter1 = result.substring(i-1,i);
                $('#l'+i).html("<p class='letter' onclick=\"onLetterClick('"+letter1+"')\">"+letter1+"</p>");
            }
            
        }
    });
}